#!/usr/bin/perl

#
# Installationsdatei des EUSs
#

#  -------------------- [Copyright Informationen] --------------------
#
#  Titel:                     Installationsscript
#  Version:                1.0
#  Datum:                  21.04.2003, 22:03 Uhr
#  Autor:                   Erik Bertram <webmaster@cgi-world.de>
#  eMail:                   webmaster@cgi-world.de
#
#  Beschreibung:       Installationsscript zum Installieren diverser
#                              Softwares von Erik Bertram.
#
#  Copyright:             Copyright (c) by Erik Bertram, 2001-2003
#                              Alle Rechte vorbehalten. All Rights Reserved.
#
#  Kontakt:                Erik Bertram
#                              Schopenhauerstrae 1a
#                              D-55606 Kirn
#
#  Homepage:           <http://www.erik.cgi-world.de>
#                              http://www.cgi-world.de
#
#  -------------------- [Lizenzbedingungen] --------------------
#
#  (1)  Diese Lizenz erlaubt es Ihnen, die Software EUS zu nutzen.
#  (2)  Als Nutzer der Software knnen Sie diese auf eigenes Risiko
#       Ihren ganz persnlichen Wnschen anpassen. Erik Bertram
#       bernimmt nach einer nderung keine Haftung mehr!
#  (3)  Die Weitergabe der Software an Dritte ist erlaubt! Dies darf
#        dann aber nur geschehen, wenn die Software im Originalzustand
#        vorhanden ist. Die Weitergabe angepasster oder vernderter
#        Versionen ist untersagt.
#  (4)  In der Software muss das jeweilige Copyright (c) in dem Script
#        sowie am Ende jeder Seite vorhanden sein. Eine Vernderung
#        des Copyrights ist nicht gestattet.
#  (5)  Die Software darf nicht verkauft oder in einer anderen Form damit
#        Provid gemacht werden. Sie ist als Freeware online erhltlich.
#  (6)  Der Betreiber verpflichtet sich whrend der Nutzung der Software
#        diese Lizenz weiter zu erhalten.
#  (7)  Die Dateien werden ohne Funktions- oder Sicherheitsgarantie zum
#        Download angeboten. Erstattungen sind nicht mglich.
#  (8)  Bei einem Versto gegen die Lizenz kann diese dem Betreiber
#        jederzeit durch Erik Bertram entzogen und so die Nutzung der
#        Software untersagt werden.
#  (9)  Diese Lizenz ist unbegrenzt lang nutzbar und auch fr neuere
#        Versionen gltig.
#  (10) Durch Nutzung der Software erklren Sie sich mit dem
#         Lizenzabkommen einverstanden.
#
#  Stand: 02.03.2003
#

use CGI::Carp qw(fatalsToBrowser);

read(STDIN, $input, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $input);
foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

	$FORM{$name} = $value;
}

@vars = split(/&/, $ENV{QUERY_STRING});
foreach $var (@vars) {
	($v,$i) = split(/=/, $var);
	$v =~ tr/+/ /;
	$v =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$i =~ tr/+/ /;
	$i =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$i =~ s/<!--(.|\n)*-->//g;
	$INFO{$v} = $i;
}

if($INFO{'action'} ne "") {
	$action = $INFO{'action'};
}else {
	$action = $FORM{'action'};
}

# Weiterleiten

if ($action eq "install") { &install; }
else { &show_install; }

# Installation vorbereiten

sub show_install {

	if($^O =~ m/win/i){
		$flock2 = " checked";
		$flock = "";
	}else{
		$flock = " checked";
		$flock2 = "";
	}

	@mail = ("/bin/sendmail","/sbin/sendmail","/usr/lib/sendmail","/usr/bin/sendmail","/usr/share/sendmail","/usr/sbin/sendmail","/usr/src/sendmail","/etc/sendmail","/bin/sendmail");
	foreach $i (@mail) {
		$mailprog = $i if((-e("$i")) && (-X("$i")));
	}

print "Content-type: text/html\n\n";
print <<"EOF";
<html>
<head>
<title>Installation des EUS - (c) Copyright by Erik Bertram</title>
</head>
<body>
<center><font face="Verdana, Arial" size="5">Installation des EUS</font></center><br>
<table align="center" width="70%" cellpadding="3" cellspacing="0" style="border: #B4B4B4 1px solid;">
  <tr>
    <td align="left" bgcolor="#B4B4B4" style="border-bottom: #B4B4B4 1px solid;"><font size="3" face="Arial, Verdana">&#0187; <b>Willkommen!</b></font></td>
  </tr>
  <tr>
    <td align="left" bgcolor="#EBEBEB" style="border-bottom: #FFFFFF 1px solid;">
    <font face="Arial, Verdana" size="2">
    <b>Willkommen bei der Installationsroutine des EUS!</b><br><br>
    Das EUS wird nun in den n&auml;chsten paar Minuten installiert und konfiguriert. Folgen Sie einfach nachfolgend der Installationsbeschreibung. Sollten Fehler oder Probleme
    auftreten, ziehen Sie die beiliegende Supportdatei zur Hilfe.<br><br>
    Viel Erfolg!
    </font>
    </td>
  </tr>
</table><br>
<form name="install" action="install.cgi?action=install" method="post">
<table align="center" width="70%" cellpadding="3" cellspacing="0" style="border: #B4B4B4 1px solid;">
  <tr>
    <td align="left" colspan="2" bgcolor="#B4B4B4" style="border-bottom: #B4B4B4 1px solid;"><font size="3" face="Arial, Verdana"><b>Systemeingaben</b></font> <font size="2" face="Arial, Verdana">(*pflicht)</font></td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid; border-right: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>HTTP Pfad zum cgi-bin Verzeichnis</b></font><br><font face="Arial, Verdana" size="1">Geben Sie hier den ganzen HTTP Pfad zum cgi-bin Verzeichnis an. (z.B. http://www.domain.de/cgi-bin)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid;">
    <input type="text" name="cgi" value="http://$ENV{'HTTP_HOST'}/cgi-bin" size="30">
    </td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid; border-right: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>HTTP Pfad zum Grafik Verzeichnis</b></font><br><font face="Arial, Verdana" size="1">Geben Sie hier den ganzen HTTP Pfad zum Grafik Verzeichnis (images) an. (z.B. http://www.domain.de/images)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid;">
    <input type="text" name="image" value="http://$ENV{'HTTP_HOST'}/images" size="30">
    </td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-right: #B4B4B4 1px solid; border-bottom: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>Absoluter Pfad</b></font><br><font face="Arial, Verdana" size="1">Geben Sie den absoluten Pfad an, wohin die hochgeladenen Dateien gespeichert werden sollen. (z.B. files)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2">
    <input type="text" name="absolut" value="files" size="30">
    </font>
    </td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-right: #B4B4B4 1px solid; border-bottom: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>GMT</b></font><br><font face="Arial, Verdana" size="1">Geben Sie hier die Zeitverschiebung des Servers ein. (z.B. +2, 0, -3)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid;">
    <input type="text" name="gmt" value="0" size="30">
    </td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-right: #B4B4B4 1px solid; border-bottom: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>SMTP / Sendmail</b></font><br><font face="Arial, Verdana" size="1">Geben Sie hier das E-Mailprogramm (SMTP/Sendmail) ein. (z.B. "/usr/lib/sendmail")</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid;">
    <input type="text" name="smtp" value="$mailprog" size="30">
    </td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-right: #B4B4B4 1px solid; border-bottom: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>Flock</b></font><br><font face="Arial, Verdana" size="1">Geben Sie hier an, ob Dateien geflockt werden sollen. (Linux = Ja, Windows = Nein)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2">
    Linux <input type="radio" name="flock" value="1"$flock>&nbsp;&nbsp;&nbsp;Windows <input type="radio" name="flock" value="2"$flock2>
    </font>
    </td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-right: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>CHMOD setzen</b></font><br><font face="Arial, Verdana" size="1">Geben Sie an, ob bei der Installation die CHMODS gesetzt werden sollen. (Linux = Ja, Windows = Nein)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB">
    <font face="Arial, Verdana" size="2">
    Ja <input type="radio" name="chmod" value="1"$flock>&nbsp;&nbsp;&nbsp;Nein <input type="radio" name="chmod" value="2"$flock2>
    </font>
    </td>
  </tr>
</table><br>
<table align="center" width="70%" cellpadding="3" cellspacing="0" style="border: #B4B4B4 1px solid;">
  <tr>
    <td align="left" colspan="2" bgcolor="#B4B4B4" style="border-bottom: #B4B4B4 1px solid;"><font size="3" face="Arial, Verdana"><b>Pers&ouml;nliche Eingaben</b></font> <font size="2" face="Arial, Verdana">(*pflicht)</font></td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid; border-right: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>Benutzername</b></font><br><font face="Arial, Verdana" size="1">Geben Sie hier Ihren Benutzernamen ein. (z.B. Max)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid;">
    <input type="text" name="name" size="30">
    </td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid; border-right: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>Passwort</b></font><br><font face="Arial, Verdana" size="1">Geben Sie hier Ihre Passwort zum Einloggen ein. (z.B. 123456)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid;">
    <input type="password" name="pass" size="30">
    </td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid; border-right: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>Passwort</b></font><br><font face="Arial, Verdana" size="1">Geben Sie hier wiederholt Ihre Passwort zum Einloggen ein. (z.B. 123456)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB" style="border-bottom: #B4B4B4 1px solid;">
    <input type="password" name="pass2" size="30">
    </td>
  </tr>
  <tr>
    <td align="left" width="70%" bgcolor="#EBEBEB" style="border-right: #B4B4B4 1px solid;">
    <font face="Arial, Verdana" size="2"><b>E-Mail</b></font><br><font face="Arial, Verdana" size="1">Geben Sie hier Ihre E-Mail ein, die auch im G&auml;stebuch zu sehen ist. (z.B. name\@provider.xy)</font>
    </td>
    <td align="center" width="30%" bgcolor="#EBEBEB">
    <input type="text" name="email" size="30">
    </td>
  </tr>
</table><br><br>
<center>
<input type="submit" value=" Installieren! ">&nbsp;&nbsp;<input type="reset" value=" L&ouml;schen ">
</center>
</form>
<hr width="70%" align="center" size="1" color="#000000">
<center><font face="Verdana, Arial" size="1">
EUS Installationsscript<br>
(c) Copyright by Erik Bertram<br>
<a href="http://www.cgi-world.de" target="_blank">http://www.cgi-world.de</a>
</font>
</center>
</body>
</html>
EOF

	exit(0);

}

# Script installieren

sub install {

	if($FORM{'cgi'} eq ""){ &error("Bitte geben Sie einen HTTP Pfad ein!"); }
	if($FORM{'cgi'} !~ /http:\/\//){ &error("Bitte geben Sie einen gltigen HTTP Pfad ein!"); }
	if($FORM{'image'} eq ""){ &error("Bitte geben Sie einen Grafik Pfad ein!"); }
	if($FORM{'image'} !~ /http:\/\//){ &error("Bitte geben Sie einen gltigen Grafik Pfad ein!"); }
	if($FORM{'absolut'} eq ""){ &error("Bitte geben Sie einen absoluten Pfad ein!"); }
	if($FORM{'gmt'} eq ""){ &error("Bitte geben Sie einen GMT Wert ein!"); }
	if($FORM{'gmt'} !~ /[\+|\-|0]/){ &error("Bitte geben Sie einen gltigen GMT Wert ein!"); }
	if($FORM{'smtp'} eq ""){ &error("Bitte geben Sie einen SMTP/Sendmail Pfad ein!"); }
	if($FORM{'name'} eq ""){ &error("Bitte geben Sie einen Benutzernamen ein!"); }
	if($FORM{'pass'} eq ""){ &error("Bitte geben Sie ein Passwort ein!"); }
	if($FORM{'pass2'} eq ""){ &error("Bitte geben Sie das Passwort wiederholt ein!"); }
	if($FORM{'pass'} ne $FORM{'pass2'}){ &error("Passwrter sind nicht identisch!"); }
	if($FORM{'email'} eq ""){ &error("Bitte geben Sie Ihre E-Mail Adresse ein!"); }
	if($FORM{'email'} !~ m/^([a-zA-z_0-9\-\.]+)(\@)([a-zA-z_0-9\-\.]+)(\.)(\w+)/){ &error("Bitte geben Sie eine gltige E-Mail Adresse ein!"); }

	@chmod755 = ("eus.cgi");

	mkdir($FORM{'absolut'}) if(!-d "$FORM{'absolut'}");

	@chmod777 = ("data",
			"data/config.txt",
			"data/email.txt",
			"data/filedata.txt",
			"data/suffixfiles.txt",
			"$FORM{'absolut'}");

	opendir(D, "templates") || die "Can't read DIR: 'templates'!\n$!";
	@temp = grep(/htm$/ , (readdir(D)));
	closedir(D);

	push(@chmod777, @temp);

	if($FORM{'chmod'} eq "1"){
		foreach $a (@chmod755){
			chmod(0755, "$FORM{'cgi'}/$a");
			$a =~ s/^\///g;
			if((-r("$a")) && (-e("$a")) && (-x("$a"))){
				$c755 .= "$a<br>";
			}else{
				$c755 .= "$a: <font color=\"red\">CHMOD nicht korrekt gesetzt!</font><br>";
			}
		}
	}

	if($FORM{'chmod'} eq "1"){
		foreach $a (@chmod777) {
			chmod(0777, "$FORM{'cgi'}/$a");
			$a =~ s/^\///g;
			if((-r("$a")) && (-e("$a")) && (-w("$a"))){
				$c777 .= "$a<br>";
			}else{
				$c777 .= "$a: <font color=\"red\">CHMOD nicht korrekt gesetzt!</font><br>";
			}
		}
	}

	$c755 = "CHMOD Funktion deaktiviert!" if($c755 eq "");
	$c777 = "CHMOD Funktion deaktiviert!" if($c777 eq "");

	if($FORM{'gmt'} eq "0"){
		$TimeGMT = time();
	}elsif($gmt =~ m/^\-/){
		$gmt2 = $FORM{'gmt'};
		$gmt2 =~ s/[^0-9]//g;
		$TimeGMT = time() - ($gmt2 * 3600);
	}elsif ($FORM{'gmt'} =~ m/^\+/){
		$gmt2 = $FORM{'gmt'};
		$gmt2 =~ s/[^0-9]//g;
		$TimeGMT = time() + ($gmt2 * 3600);
	}

	($sec, $min, $hours, $day, $month, $year, $wday, $yday, $isdst) = localtime($TimeGMT);

	$month += 1;
	$year += 1900;
	$min = "0$min" if($min < "10");
	$sec = "0$sec" if($sec < "10");
	$hours = "0$hours" if($hours < "10");
	$day = "0$day" if($day < "10");
	$month = "0$month" if($month < "10");

	$datum = "$day.$month.$year";

	($name, $provider) = split(/\@/, $FORM{'email'});
	$email = "$name\\\@$provider";

	if($FORM{'flock'} eq "1"){ $flock = "0"; }
	else { $flock = "1"; }

	if($FORM{'chmod'} eq "1"){ $chmod = "0"; }
	else { $chmod = "1"; }

	open(F, "> data/config.txt") || die "Can't open data for writing: 'data/config.txt'!\n$!";
	print F "\$cgi = \"$FORM{'cgi'}\";\n\$absolutfile = \"$FORM{'absolut'}\";\n\$graphics = \"$FORM{'image'}\";\n\$email = \"$email\";\n\$mailprog = \"$FORM{'smtp'}\";\n\$gmt = \"$FORM{'gmt'}\";\n\$adminname = \"$FORM{'name'}\";\n\$adminpassword = \"$FORM{'pass'}\";\n\$deletepassword = \"$FORM{'pass'}\";\n\$uploadpassword = \"$FORM{'pass'}\";\n\$flock = \"$flock\";\n\$uploadmail = \"1\";\n\$renamefile = \"1\";\n\$description = \"0\";\n\$dessize = \"50\";\n\$datapage = \"10\";\n\$uploadname = \"0\";\n\$uploademail = \"0\";\n\$chmod = \"$chmod\";\n\$sortfiles = \"0\";\n\$checksuffix = \"0\";\n\$maxupload = \"100\";\n\$eurodatum = \"0\";\n\n1;";
	close(F);

print "Content-type: text/html\n\n";
print <<"EOF";
<html>
<head>
<title>Installation des EUS - (c) Copyright by Erik Bertram</title>
</head>
<body>
<center><font face="Verdana, Arial" size="5">Installation des EUS</font></center><br>
<table align="center" width="70%" cellpadding="3" cellspacing="0" style="border: #B4B4B4 1px solid;">
  <tr>
    <td align="left" bgcolor="#B4B4B4" style="border-bottom: #B4B4B4 1px solid;"><font size="3" face="Arial, Verdana">&#0187; <b>Installation erfolgreich!</b></font></td>
  </tr>
  <tr>
    <td align="left" bgcolor="#EBEBEB" style="border-bottom: #FFFFFF 1px solid;">
    <font face="Arial, Verdana" size="2">
    <b>Herzlichen Gl&uuml;ckwunsch!</b><br><br>
    Das Uploadscript konnte Ihre Daten erfolgreich verarbeiten. Es ist nun fertig installiert und zum Betrieb bereit.<br><br>
    Hier nochmal Ihre pers&ouml;nlichen Daten:<br><br>
    Benutzername: <b>$FORM{'name'}</b><br>
    E-Mail: <b>$FORM{'email'}</b><br>
    Passwort: <b>$FORM{'pass'}</b><br>
    Pfad zum Umfragescript: <b>$FORM{'cgi'}/eus.cgi</b><br><br>
    CHMOD 755:<br>
    $c755
    <br><br>
    CHMOD 777:<br>
    $c777
    <br><br>
    Die Installation ist hiermit abgeschlossen!<br>
    Viel Erfolg! - <a href="eus.cgi">Uploadscript aufrufen</a>
    </font>
    </td>
  </tr>
</table><br>
<hr width="70%" align="center" size="1" color="#000000">
<center><font face="Verdana, Arial" size="1">
EUS Installationsscript<br>
(c) Copyright by Erik Bertram<br>
<a href="http://www.cgi-world.de" target="_blank">http://www.cgi-world.de</a>
</font>
</center>
</body>
</html>
EOF

	exit(0);

}

# Fehlermeldungen

sub error {

print "Content-type: text/html\n\n";
print <<"EOF";
<html>
<head>
<title>Installation des EUS - (c) Copyright by Erik Bertram</title>
</head>
<body>
<center><font face="Verdana, Arial" size="5">Installation des EUS</font></center><br>
<table align="center" width="70%" cellpadding="3" cellspacing="0" style="border: #B4B4B4 1px solid;">
  <tr>
    <td align="left" bgcolor="#B4B4B4" style="border-bottom: #B4B4B4 1px solid;"><font size="3" face="Arial, Verdana">&#0187; <b>Fehler bei der Eingabe</b></font></td>
  </tr>
  <tr>
    <td align="left" bgcolor="#EBEBEB" style="border-bottom: #FFFFFF 1px solid;">
    <font face="Arial, Verdana" size="2">
    <b>Bei Ihrer Eingabe ist ein Fehler unterlaufen: $_[0]</b><br><br>
    Klicken Sie <a href="javascript:history.back();">hier</a> oder benutzen Sie die "Zur&uuml;ck" - Funktion Ihres Browsers!
    </font>
    </td>
  </tr>
</table><br>
<hr width="70%" align="center" size="1" color="#000000">
<center><font face="Verdana, Arial" size="1">
EUS Installationsscript<br>
(c) Copyright by Erik Bertram<br>
<a href="http://www.cgi-world.de" target="_blank">http://www.cgi-world.de</a>
</font>
</center>
</body>
</html>
EOF

	exit(0);

}